CREATE OR REPLACE PROCEDURE ATUALIZA_SALDO_CONS_FKB(
  P_CDCLIENTE     IN VARCHAR,
  P_CDCONSUMIDOR  IN VARCHAR,
  P_CDFAMILISALD  IN VARCHAR,
  P_DTINIEVOLUCAO IN DATE)
AS
  V_CDCLIENTE     VARCHAR(21);
  V_MENORIGUAL    FLOAT;
  V_MAIORIGUAL    FLOAT;
  V_REGMENORIGUAL FLOAT;
  V_COUNTSALDO    FLOAT;
  V_DTLANCAMENTO  DATE;
  V_UCONSUMIDOR   VARCHAR(1);
  V_DTMOVEXTCONS  DATE;
  V_DTMOVANTE     DATE;
  V_VRMOVEXTCONS  FLOAT;
  V_IDTPMOVEXT    VARCHAR(1);
  V_VRSALDCONEXT  FLOAT;
  V_VRATUALPECONS FLOAT;
  V_NRSEQMOVEXT   VARCHAR(3);
  V_SALDOCONS     FLOAT;
  V_CHAVE         VARCHAR(30);
  V_CDCONTADOR    VARCHAR(10);
BEGIN
   /*Retorna a primeira data/hora a partir da data/hora informada (maior ou igual)*/
   SELECT
       MIN(DTMOVEXTCONS) INTO V_DTLANCAMENTO
   FROM
      EXTRATOCONS
   WHERE
      (CDCLIENTE      = P_CDCLIENTE   ) AND
      (CDFAMILISALD   = P_CDFAMILISALD) AND
      (CDCONSUMIDOR   = P_CDCONSUMIDOR) AND
      (DTMOVEXTCONS  >= P_DTINIEVOLUCAO);
   IF V_DTLANCAMENTO IS NOT NULL THEN
      /*Seleciona o lanamento*/
      BEGIN
         SELECT
             DTMOVEXTCONS, VRMOVEXTCONS, IDTPMOVEXT, VRSALDCONEXT, TO_CHAR(DTMOVEXTCONS,'DD/MM/YYYY HH24:MI:SS')||NRSEQMOVEXT AS CHAVE
         INTO
             V_DTMOVEXTCONS, V_VRMOVEXTCONS, V_IDTPMOVEXT, V_VRSALDCONEXT, V_CHAVE
         FROM
            EXTRATOCONS
         WHERE
            (CDCLIENTE      = P_CDCLIENTE   ) AND
            (CDFAMILISALD   = P_CDFAMILISALD) AND
            (CDCONSUMIDOR   = P_CDCONSUMIDOR) AND
            (DTMOVEXTCONS   = V_DTLANCAMENTO) AND
            (ROWNUM = 1)
         ORDER BY
            DTMOVEXTCONS,NRSEQMOVEXT;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_DTMOVEXTCONS := NULL;
            V_VRMOVEXTCONS := 0;
            V_IDTPMOVEXT   := NULL;
            V_VRSALDCONEXT := 0;
      END;
      /*Grava no valor do saldo, o valor da movimentao, visto que no h lanamento anterior*/
      UPDATE
         EXTRATOCONS
         SET VRSALDCONEXT = ROUND(V_VRSALDCONEXT, 2)
      WHERE
         (CDCLIENTE      = P_CDCLIENTE   ) AND
         (CDFAMILISALD   = P_CDFAMILISALD) AND
         (CDCONSUMIDOR   = P_CDCONSUMIDOR) AND
         (DTMOVEXTCONS   = V_DTLANCAMENTO   );
      /*Retorna o nmero de registros maiores ou iguais  data/hora informada*/
      SELECT
         COUNT(DTMOVEXTCONS)
      INTO
         V_MAIORIGUAL
      FROM
         EXTRATOCONS
      WHERE
         (CDCLIENTE     = P_CDCLIENTE   ) AND
         (CDFAMILISALD  = P_CDFAMILISALD) AND
         (CDCONSUMIDOR  = P_CDCONSUMIDOR) AND
         (DTMOVEXTCONS >= V_DTLANCAMENTO   );

      /*Atualiza lanamentos posteriores*/
      IF V_MAIORIGUAL > 1 THEN
         V_DTMOVANTE := SYSDATE;
         V_CDCONTADOR := 1;
         FOR CUR_EXTRATOCONS IN
            (SELECT
               DTMOVEXTCONS,VRMOVEXTCONS,IDTPMOVEXT,VRSALDCONEXT, NRSEQMOVEXT
            FROM
               EXTRATOCONS
            WHERE
               (CDCLIENTE     = P_CDCLIENTE   ) AND
               (CDFAMILISALD  = P_CDFAMILISALD) AND
               (CDCONSUMIDOR  = P_CDCONSUMIDOR) AND
               (DTMOVEXTCONS >= V_DTMOVEXTCONS) AND
               ((TO_CHAR(DTMOVEXTCONS,'DD/MM/YYYY HH24:MI:SS')||NRSEQMOVEXT) <> (V_CHAVE))
            ORDER BY
               DTMOVEXTCONS, NRSEQMOVEXT) LOOP

            V_VRMOVEXTCONS := CUR_EXTRATOCONS.VRMOVEXTCONS;

            IF CUR_EXTRATOCONS.IDTPMOVEXT = 'V' THEN
                V_VRMOVEXTCONS := (-1) * CUR_EXTRATOCONS.VRMOVEXTCONS;
            ELSIF CUR_EXTRATOCONS.IDTPMOVEXT = 'D' THEN
                V_VRMOVEXTCONS := (-1) * CUR_EXTRATOCONS.VRMOVEXTCONS;
			ELSIF CUR_EXTRATOCONS.IDTPMOVEXT = 'E' THEN
                V_VRMOVEXTCONS := (-1) * CUR_EXTRATOCONS.VRMOVEXTCONS;
            END IF;

            IF V_DTMOVANTE <> CUR_EXTRATOCONS.DTMOVEXTCONS THEN

               IF V_CDCONTADOR = '1' THEN
                  V_VRATUALPECONS := (NVL(V_VRSALDCONEXT,0) + V_VRMOVEXTCONS);
               ELSE
                  SELECT
                      MAX(NRSEQMOVEXT)
                   INTO
                      V_NRSEQMOVEXT
                   FROM
                      EXTRATOCONS
                   WHERE
                      (CDCLIENTE     = P_CDCLIENTE   ) AND
                      (CDFAMILISALD  = P_CDFAMILISALD) AND
                      (CDCONSUMIDOR  = P_CDCONSUMIDOR) AND
                      (DTMOVEXTCONS  = (SELECT
                                           MAX(DTMOVEXTCONS)
                                        FROM
                                           EXTRATOCONS
                                        WHERE
                                           (CDCLIENTE    = P_CDCLIENTE   ) AND
                                           (CDFAMILISALD = P_CDFAMILISALD) AND
                                           (CDCONSUMIDOR = P_CDCONSUMIDOR) AND
                                           (DTMOVEXTCONS < CUR_EXTRATOCONS.DTMOVEXTCONS)));

                   /*Retorna o saldo imediatamente anterior*/

                   SELECT
                      (NVL(MAX(VRSALDCONEXT),0) + V_VRMOVEXTCONS)
                   INTO
                      V_VRATUALPECONS
                   FROM
                      EXTRATOCONS
                   WHERE
                      (CDCLIENTE       = P_CDCLIENTE   ) AND
                      (CDFAMILISALD    = P_CDFAMILISALD) AND
                      (CDCONSUMIDOR    = P_CDCONSUMIDOR) AND
                      (NRSEQMOVEXT   = V_NRSEQMOVEXT ) AND
                      (DTMOVEXTCONS = (SELECT
                                         MAX(DTMOVEXTCONS)
                                       FROM
                                          EXTRATOCONS
                                       WHERE
                                          (CDCLIENTE     = P_CDCLIENTE   ) AND
                                          (CDFAMILISALD  = P_CDFAMILISALD) AND
                                          (CDCONSUMIDOR  = P_CDCONSUMIDOR) AND
                                          (NRSEQMOVEXT   = V_NRSEQMOVEXT ) AND
                                          (DTMOVEXTCONS  < CUR_EXTRATOCONS.DTMOVEXTCONS    )
                                      )
                      );
               END IF;
            ELSE
               SELECT
                  LPAD(TO_NUMBER(NVL(MAX(CUR_EXTRATOCONS.NRSEQMOVEXT),0)) - 1,3,'0')
               INTO
                  V_NRSEQMOVEXT
               FROM
                  DUAL;
               SELECT
                  (NVL(MAX(VRSALDCONEXT),0) + V_VRMOVEXTCONS)
               INTO
                  V_VRATUALPECONS
               FROM
                  EXTRATOCONS
               WHERE
                  (CDCLIENTE     = P_CDCLIENTE   ) AND
                  (CDFAMILISALD  = P_CDFAMILISALD) AND
                  (CDCONSUMIDOR  = P_CDCONSUMIDOR) AND
                  (NRSEQMOVEXT   = V_NRSEQMOVEXT ) AND
                  (DTMOVEXTCONS  = CUR_EXTRATOCONS.DTMOVEXTCONS);
            END IF;

            /*Atualiza os lanamentos*/
            UPDATE
               EXTRATOCONS
               SET VRSALDCONEXT = ROUND(V_VRATUALPECONS, 2)
            WHERE
               (CDCLIENTE      = P_CDCLIENTE   ) AND
               (CDFAMILISALD   = P_CDFAMILISALD) AND
               (CDCONSUMIDOR   = P_CDCONSUMIDOR) AND
               (NRSEQMOVEXT    = CUR_EXTRATOCONS.NRSEQMOVEXT) AND
               (DTMOVEXTCONS   = CUR_EXTRATOCONS.DTMOVEXTCONS);
            SELECT COUNT(CDCLIENTE)
              INTO V_SALDOCONS
              FROM SALDOCONS
             WHERE CDCLIENTE = P_CDCLIENTE
               AND CDCONSUMIDOR = P_CDCONSUMIDOR
               AND CDFAMILISALD = P_CDFAMILISALD;

            IF V_SALDOCONS >= 1 THEN
               UPDATE SALDOCONS
                  SET VRSALDCONFAM = ROUND(V_VRATUALPECONS, 2)
                WHERE CDCLIENTE = P_CDCLIENTE
                  AND CDFAMILISALD = P_CDFAMILISALD
                  AND CDCONSUMIDOR = P_CDCONSUMIDOR;
            ELSE
               INSERT INTO SALDOCONS
                      (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM)
               VALUES (P_CDCLIENTE, P_CDCONSUMIDOR, P_CDFAMILISALD, ROUND(V_VRATUALPECONS, 2));
            END IF;
            V_DTMOVANTE := CUR_EXTRATOCONS.DTMOVEXTCONS;
            V_CDCONTADOR := V_CDCONTADOR+1;
         END LOOP;
      END IF;

      IF V_MAIORIGUAL = 1 THEN
         SELECT COUNT(CDCLIENTE)
           INTO V_SALDOCONS
           FROM SALDOCONS
          WHERE CDCLIENTE = P_CDCLIENTE
            AND CDCONSUMIDOR = P_CDCONSUMIDOR
            AND CDFAMILISALD = P_CDFAMILISALD;

         IF V_SALDOCONS >= 1 THEN
            UPDATE SALDOCONS
               SET VRSALDCONFAM = ROUND(V_VRSALDCONEXT, 2)
             WHERE CDCLIENTE = P_CDCLIENTE
               AND CDFAMILISALD = P_CDFAMILISALD
               AND CDCONSUMIDOR = P_CDCONSUMIDOR;
         ELSE
            INSERT INTO SALDOCONS
                   (CDCLIENTE, CDCONSUMIDOR, CDFAMILISALD, VRSALDCONFAM)
            VALUES (P_CDCLIENTE, P_CDCONSUMIDOR, P_CDFAMILISALD, ROUND(V_VRSALDCONEXT, 2));
         END IF;
      END IF;

   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('ATUALIZA_SALDO_CONS_FKB','6.43.067'); END;
/

