CREATE OR REPLACE PROCEDURE SPED_ECF_BLOCOK_SALDOS(
   P_CDEMPRESA IN EMPRESA.CDEMPRESA%TYPE,
   P_ANO IN VARCHAR,
   P_NRSEQARQMAG IN VARCHAR,
   P_NRORDEMATUAL IN NUMBER,
   P_NRORDENACAO OUT NUMBER)
IS
   V_NRORDREGARQ NUMBER;
   V_LINHA VARCHAR(4000);
   V_TEMP VARCHAR2(12);
   V_LANCPERIODO VARCHAR2(01);
   V_VRINICIAL NUMBER;
   V_VRDEBITO NUMBER;
   V_VRCREDITO NUMBER;
   V_VRFINAL NUMBER;
   V_IDFORMAPUR VARCHAR2(03);
   V_CONTAREFE VARCHAR2(20);
   V_AUXILIAR VARCHAR2(200);
   V_COUNT NUMBER;
   V_INSEREK030 VARCHAR2(01);
   V_DATAINICIAL DATE;
   V_DATAFINAL DATE;
   V_MES VARCHAR2(02);

BEGIN
   V_NRORDREGARQ := P_NRORDEMATUAL;
   BEGIN
      SELECT '|K001' || '|'||  /* NOME DO REGISTRO */
                 '0' || '|'    /* INDICADOR DE MOVIMENTO
                                  1 - SEM DADOS INFORMADOS
                                  0 - COM DADOS INFORMADOS */
        INTO V_LINHA
        FROM DUAL;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_LINHA := NULL;
   END;
   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
      (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
      (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_LINHA, P_NRSEQARQMAG);

   BEGIN
      SELECT FORMAAPUR
        INTO V_TEMP
        FROM REG0010_ECF
       WHERE CDEMPRESA = P_CDEMPRESA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_TEMP := NULL;
   END;

   BEGIN
      SELECT IDFORMAPUR
        INTO V_IDFORMAPUR
        FROM EMPRESA
       WHERE CDEMPRESA = P_CDEMPRESA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_IDFORMAPUR := NULL;
   END;

   IF V_IDFORMAPUR IN ('LPM', 'LPT') THEN
      V_IDFORMAPUR := 'P';
   ELSIF V_IDFORMAPUR IN ('LRM', 'LRT') THEN
      V_IDFORMAPUR := 'R';
   END IF;

   IF V_TEMP = 'A' THEN
      BEGIN
         SELECT '|K030'         ||'|'|| /* NOME DO REGISTRO */
                '0101'||P_ANO   ||'|'|| /* DATA INICIAL DO PERIODO */
                '3112'||P_ANO   ||'|'|| /* DATA FINAL DO PERIODO */
                'A00'           ||'|'   /* PERIODO DE APURACAO.
                                           NO CASO DE APURACAO ANUAL,  OBRIGATRIO O REGISTRO A00 */
           INTO V_LINHA
           FROM DUAL;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
            V_LINHA := NULL;
      END;
      V_NRORDREGARQ := V_NRORDREGARQ + 1;
      INSERT INTO ARQMAGNETICO
         (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
         (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_LINHA, P_NRSEQARQMAG);
      FOR C_K155_AUX IN (
         SELECT CDCONTCTBL, DECODE(V_IDFORMAPUR, 'R', CDCONTPLANREFE, CDCONTREFEPRE) CDCONTPLANREFE, CDCONTREFEAUX
           FROM CONTCTBL
          WHERE (((CDCONTPLANREFE IS NOT NULL) AND (V_IDFORMAPUR = 'R')) OR
                 ((CDCONTREFEPRE IS NOT NULL) AND (V_IDFORMAPUR = 'P')))
            AND IDNATUCONT IN ('01', '02', '03')
            AND IDCONTCCUS <> 'R'
            AND IDTIPOCONT = 'A'
          ORDER BY 1, 2) LOOP

         FOR C_K155 IN(
            SELECT '|K155|'||
                   SALDFIN.CDCONTCTBL||
                   '||'||
                   REPLACE(LTRIM(TO_CHAR(ABS(NVL(SALDINI.VRSALDINI,0)),'9999999999990.00')||'|'||DECODE(SALDINI.VRSALDINI, ABS(SALDINI.VRSALDINI), 'C', 'D')),'.',',') ||'|'||
                   REPLACE(LTRIM(TO_CHAR(ABS(NVL(DEBITO.DEBITO,0)),'9999999999990.00')),'.',',') ||'|'||
                   REPLACE(LTRIM(TO_CHAR(NVL(CREDITO.CREDITO,0), '9999999999990.00')),'.',',') ||'|'||
                   REPLACE(LTRIM(TO_CHAR(ABS(NVL(SALDFIN.VRSALDFIN,0)),'9999999999990.00')||'|'||DECODE(SALDFIN.VRSALDFIN, ABS(SALDFIN.VRSALDFIN), 'C', 'D')),'.',',') ||'|' AS DSLINHA,
                   CREDITO, DEBITO
            FROM (SELECT L.CDCONTCTBL, SUM(ROUND(L.VRLANCAMENT,2)) AS DEBITO
                    FROM LANCCONT L
                   WHERE L.VRLANCAMENT < 0
                     AND L.CDEMPRESA = P_CDEMPRESA
                     AND L.DTLANCCONT BETWEEN '01/01/'||P_ANO AND TO_DATE('31/12/'||P_ANO)
                     AND L.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                   GROUP BY L.CDCONTCTBL) DEBITO,

                 (SELECT L.CDCONTCTBL, SUM(ROUND(L.VRLANCAMENT,2)) AS CREDITO
                  FROM LANCCONT L
                  WHERE L.VRLANCAMENT > 0
                    AND L.CDEMPRESA = P_CDEMPRESA
                    AND L.DTLANCCONT BETWEEN '01/01/'||P_ANO AND TO_DATE('31/12/'||P_ANO)
                    AND L.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                  GROUP BY L.CDCONTCTBL) CREDITO,
                 (SELECT S.CDCONTCTBL, NVL(S.VRSALDEMPR, 0) AS VRSALDINI
                  FROM SALDEMPR S
                  WHERE S.CDEMPRESA = P_CDEMPRESA
                    AND S.DTSALDEMPR = TO_DATE('01/01/'||P_ANO) - 1
                    AND S.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                    AND S.VRSALDEMPR <> 0) SALDINI,
                 (SELECT S.CDCONTCTBL, NVL(S.VRSALDEMPR, 0) AS VRSALDFIN
                   FROM SALDEMPR S
                  WHERE S.CDEMPRESA  = P_CDEMPRESA
                    AND S.DTSALDEMPR = TO_DATE('31/12/'||P_ANO)
                    AND S.CDCONTCTBL = C_K155_AUX.CDCONTCTBL) SALDFIN
            WHERE SALDFIN.CDCONTCTBL = DEBITO.CDCONTCTBL(+)
              AND SALDFIN.CDCONTCTBL = CREDITO.CDCONTCTBL(+)
              AND SALDFIN.CDCONTCTBL = SALDINI.CDCONTCTBL(+)
              AND (ABS(NVL(SALDINI.VRSALDINI,0)) + ABS(NVL(DEBITO.DEBITO,0)) + ABS(NVL(CREDITO.CREDITO,0))) <> 0
            ORDER BY SALDFIN.CDCONTCTBL) LOOP
               V_NRORDREGARQ := V_NRORDREGARQ + 1;

               INSERT INTO ARQMAGNETICO
                 (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                 (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_K155.DSLINHA, P_NRSEQARQMAG);
         END LOOP;
      END LOOP;
      FOR K355 IN
         (SELECT '|K355|' || C.CDCONTCTBL || '|' || '' || '|' ||
                  REPLACE(LTRIM(TO_CHAR(ABS(NVL(SUM(ROUND(VRLANCAMENT, 2)), 0)),'9999999999990.00')), '.', ',')|| '|' ||
                  DECODE(NVL(SUM(ROUND(VRLANCAMENT, 2)), 0), ABS(NVL(SUM(ROUND(VRLANCAMENT, 2)), 0)), 'C', 'D') || '|' AS DSLINHA
            FROM CONTCTBL C, LANCCONT L
           WHERE L.CDEMPRESA = P_CDEMPRESA
             AND L.DTLANCCONT BETWEEN '01/01/'||P_ANO AND TO_DATE('31/12/'||P_ANO)
             AND L.CDCONTCTBL  = C.CDCONTCTBL
             AND L.IDLANCINTE <> 'F'
             AND C.IDTIPOCONT  = 'A'
             AND C.IDNATUCONT  = '04'
             AND C.IDCONTCCUS <> 'R'
           GROUP BY C.CDCONTCTBL  
           ORDER BY C.CDCONTCTBL)LOOP

         V_NRORDREGARQ := V_NRORDREGARQ + 1;
         INSERT INTO ARQMAGNETICO
            (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
         VALUES
            (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), K355.DSLINHA, P_NRSEQARQMAG);
      END LOOP;
      V_COUNT := 1;
      WHILE V_COUNT <= 12 LOOP
         V_DATAINICIAL := TO_DATE('01/'||LPAD(TO_CHAR(V_COUNT),2,'0')||'/'||P_ANO);
         V_DATAFINAL := LAST_DAY(TO_DATE('01/'||LPAD(TO_CHAR(V_COUNT),2,'0')||'/'||P_ANO));
         V_MES := LPAD(TO_CHAR(V_COUNT),2,'0');
         V_INSEREK030 := 'S';
         FOR C_K155_AUX IN (
            SELECT CDCONTCTBL, DECODE(V_IDFORMAPUR, 'R', CDCONTPLANREFE, CDCONTREFEPRE) CDCONTPLANREFE, CDCONTREFEAUX
              FROM CONTCTBL
             WHERE (((CDCONTPLANREFE IS NOT NULL) AND (V_IDFORMAPUR = 'R')) OR
                    ((CDCONTREFEPRE IS NOT NULL) AND (V_IDFORMAPUR = 'P')))
               AND IDNATUCONT IN ('01', '02', '03')
               AND IDCONTCCUS <> 'R'
               AND IDTIPOCONT = 'A'
             ORDER BY 1, 2) LOOP

            FOR C_K155 IN(
               SELECT '|K155|'||
                      SALDFIN.CDCONTCTBL||
                      '||'||
                      REPLACE(LTRIM(TO_CHAR(ABS(NVL(SALDINI.VRSALDINI,0)),'9999999999990.00')||'|'||DECODE(SALDINI.VRSALDINI, ABS(SALDINI.VRSALDINI), 'C', 'D')),'.',',') ||'|'||
                      REPLACE(LTRIM(TO_CHAR(ABS(NVL(DEBITO.DEBITO,0)),'9999999999990.00')),'.',',') ||'|'||
                      REPLACE(LTRIM(TO_CHAR(NVL(CREDITO.CREDITO,0), '9999999999990.00')),'.',',') ||'|'||
                      REPLACE(LTRIM(TO_CHAR(ABS(NVL(SALDFIN.VRSALDFIN,0)),'9999999999990.00')||'|'||DECODE(SALDFIN.VRSALDFIN, ABS(SALDFIN.VRSALDFIN), 'C', 'D')),'.',',') ||'|' AS DSLINHA,
                      CREDITO, DEBITO
               FROM (SELECT L.CDCONTCTBL, SUM(ROUND(L.VRLANCAMENT,2)) AS DEBITO
                       FROM LANCCONT L
                      WHERE L.VRLANCAMENT < 0
                        AND L.CDEMPRESA = P_CDEMPRESA
                        AND L.DTLANCCONT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                        AND L.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                      GROUP BY L.CDCONTCTBL) DEBITO,

                    (SELECT L.CDCONTCTBL, SUM(ROUND(L.VRLANCAMENT,2)) AS CREDITO
                     FROM LANCCONT L
                     WHERE L.VRLANCAMENT > 0
                       AND L.CDEMPRESA = P_CDEMPRESA
                       AND L.DTLANCCONT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                       AND L.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                     GROUP BY L.CDCONTCTBL) CREDITO,
                     
                    (SELECT S.CDCONTCTBL, NVL(S.VRSALDEMPR, 0) AS VRSALDINI
                     FROM SALDEMPR S
                     WHERE S.CDEMPRESA = P_CDEMPRESA
                       AND S.DTSALDEMPR = V_DATAINICIAL - 1
                       AND S.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                       AND S.VRSALDEMPR <> 0) SALDINI,
                     
                    (SELECT S.CDCONTCTBL, NVL(S.VRSALDEMPR, 0) AS VRSALDFIN
                      FROM SALDEMPR S
                     WHERE S.CDEMPRESA  = P_CDEMPRESA
                       AND S.DTSALDEMPR = V_DATAFINAL
                       AND S.CDCONTCTBL = C_K155_AUX.CDCONTCTBL) SALDFIN
               WHERE SALDFIN.CDCONTCTBL = DEBITO.CDCONTCTBL(+)
                 AND SALDFIN.CDCONTCTBL = CREDITO.CDCONTCTBL(+)
                 AND SALDFIN.CDCONTCTBL = SALDINI.CDCONTCTBL(+)
                 AND (ABS(NVL(SALDINI.VRSALDINI,0)) + ABS(NVL(DEBITO.DEBITO,0)) + ABS(NVL(CREDITO.CREDITO,0))) <> 0
               ORDER BY SALDFIN.CDCONTCTBL) LOOP
                  /* VERIFICA SE O K030 JA FOI INSERIDO PARA O MES DO LOOP */
                  IF V_INSEREK030 = 'S' THEN
                     BEGIN
                        SELECT '|K030'                             ||'|'|| /* NOME DO REGISTRO */
                              '0101'||P_ANO                        ||'|'|| /* DATA INICIAL DO PERIODO */
                              TO_CHAR(V_DATAFINAL, 'DDMMYYYY')     ||'|'|| /* DATA FINAL DO PERIODO */
                              'A'||V_MES                           ||'|'   /* PERIODO DE APURACAO */
                          INTO V_LINHA
                          FROM DUAL;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_LINHA := NULL;
                     END;
                     V_NRORDREGARQ := V_NRORDREGARQ + 1;
                     INSERT INTO ARQMAGNETICO
                        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                     VALUES
                        (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_LINHA, P_NRSEQARQMAG);
                     V_INSEREK030 := 'N';
                  END IF;
                  V_NRORDREGARQ := V_NRORDREGARQ + 1;

                  INSERT INTO ARQMAGNETICO
                    (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                    (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_K155.DSLINHA, P_NRSEQARQMAG);
            END LOOP;
         END LOOP;

         /*-------------------------------------------------------------*/
         /* BLOCO K355 - CONTAS DE RESULTADO ANTES ENCERRAMENTO (ANUAL) */
         /*-------------------------------------------------------------*/
         FOR K355 IN
            (SELECT '|K355|' || C.CDCONTCTBL || '|' || '' || '|' ||
                     REPLACE(LTRIM(TO_CHAR(ABS(NVL(SUM(ROUND(VRLANCAMENT, 2)), 0)),'9999999999990.00')), '.', ',')|| '|' ||
                     DECODE(NVL(SUM(ROUND(VRLANCAMENT, 2)), 0), ABS(NVL(SUM(ROUND(VRLANCAMENT, 2)), 0)), 'C', 'D') || '|' AS DSLINHA
               FROM CONTCTBL C, LANCCONT L
              WHERE L.CDEMPRESA = P_CDEMPRESA
                AND L.DTLANCCONT BETWEEN TO_DATE('01/01/'||P_ANO) AND V_DATAFINAL
                AND L.CDCONTCTBL  = C.CDCONTCTBL
                AND L.IDLANCINTE <> 'F'
                AND C.IDTIPOCONT  = 'A'
                AND C.IDNATUCONT  = '04'
                AND C.IDCONTCCUS <> 'R'
              GROUP BY C.CDCONTCTBL  
              ORDER BY C.CDCONTCTBL)LOOP
            IF V_INSEREK030 = 'S' THEN
               BEGIN
                  SELECT '|K030'                             ||'|'|| /* NOME DO REGISTRO */
                        '0101'||P_ANO                        ||'|'|| /* DATA INICIAL DO PERIODO */
                        TO_CHAR(V_DATAFINAL, 'DDMMYYYY')     ||'|'|| /* DATA FINAL DO PERIODO */
                        'A'||V_MES                           ||'|'   /* PERIODO DE APURACAO */
                    INTO V_LINHA
                    FROM DUAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_LINHA := NULL;
               END;
               V_NRORDREGARQ := V_NRORDREGARQ + 1;
               INSERT INTO ARQMAGNETICO
                  (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
               VALUES
                  (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_LINHA, P_NRSEQARQMAG);
               V_INSEREK030 := 'N';
            END IF;

            V_NRORDREGARQ := V_NRORDREGARQ + 1;
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), K355.DSLINHA, P_NRSEQARQMAG);
         END LOOP;
         
         V_INSEREK030 := 'S';
         V_COUNT := V_COUNT + 1;
      END LOOP;
   ELSE
      V_COUNT := 1;
      V_DATAINICIAL := TO_DATE('01/'||LPAD(TO_CHAR(V_COUNT),2,'0')||'/'||P_ANO);
      V_DATAFINAL := LAST_DAY(ADD_MONTHS(V_DATAINICIAL, 2));
      /* GERAO DO BALANO PATRIMONIAL (TRIMESTRAL), LOGO ABAIXO SERO FEITOS OS REGISTROS TRIMESTRAIS T01 A T04) */
      WHILE V_COUNT <= 4 LOOP
         V_MES := LPAD(TO_CHAR(V_COUNT),2,'0');
         V_INSEREK030 := 'S';
         FOR C_K155_AUX IN (
            SELECT CDCONTCTBL, DECODE(V_IDFORMAPUR, 'R', CDCONTPLANREFE, CDCONTREFEPRE) CDCONTPLANREFE, CDCONTREFEAUX
              FROM CONTCTBL
             WHERE (((CDCONTPLANREFE IS NOT NULL) AND (V_IDFORMAPUR = 'R')) OR
                    ((CDCONTREFEPRE IS NOT NULL) AND (V_IDFORMAPUR = 'P')))
               AND IDNATUCONT IN ('01', '02', '03')
               AND IDCONTCCUS <> 'R'
               AND IDTIPOCONT = 'A'
             ORDER BY 1, 2) LOOP

            FOR C_K155 IN(
               SELECT '|K155|'||
                      SALDFIN.CDCONTCTBL||
                      '||'||
                      REPLACE(LTRIM(TO_CHAR(ABS(NVL(SALDINI.VRSALDINI,0)),'9999999999990.00')||'|'||DECODE(SALDINI.VRSALDINI, ABS(SALDINI.VRSALDINI), 'C', 'D')),'.',',') ||'|'||
                      REPLACE(LTRIM(TO_CHAR(ABS(NVL(DEBITO.DEBITO,0)),'9999999999990.00')),'.',',') ||'|'||
                      REPLACE(LTRIM(TO_CHAR(NVL(CREDITO.CREDITO,0), '9999999999990.00')),'.',',') ||'|'||
                      REPLACE(LTRIM(TO_CHAR(ABS(NVL(SALDFIN.VRSALDFIN,0)),'9999999999990.00')||'|'||DECODE(SALDFIN.VRSALDFIN, ABS(SALDFIN.VRSALDFIN), 'C', 'D')),'.',',') ||'|' AS DSLINHA,
                      CREDITO, DEBITO
               FROM (SELECT L.CDCONTCTBL, SUM(ROUND(L.VRLANCAMENT,2)) AS DEBITO
                       FROM LANCCONT L
                      WHERE L.VRLANCAMENT < 0
                        AND L.CDEMPRESA = P_CDEMPRESA
                        AND L.DTLANCCONT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                        AND L.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                      GROUP BY L.CDCONTCTBL) DEBITO,

                    (SELECT L.CDCONTCTBL, SUM(ROUND(L.VRLANCAMENT,2)) AS CREDITO
                     FROM LANCCONT L
                     WHERE L.VRLANCAMENT > 0
                       AND L.CDEMPRESA = P_CDEMPRESA
                       AND L.DTLANCCONT BETWEEN V_DATAINICIAL AND V_DATAFINAL
                       AND L.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                     GROUP BY L.CDCONTCTBL) CREDITO,

                    (SELECT S.CDCONTCTBL, NVL(S.VRSALDEMPR, 0) AS VRSALDINI
                     FROM SALDEMPR S
                     WHERE S.CDEMPRESA = P_CDEMPRESA
                       AND S.DTSALDEMPR = V_DATAINICIAL - 1
                       AND S.CDCONTCTBL = C_K155_AUX.CDCONTCTBL
                       AND S.VRSALDEMPR <> 0) SALDINI,

                    (SELECT S.CDCONTCTBL, NVL(S.VRSALDEMPR, 0) AS VRSALDFIN
                      FROM SALDEMPR S
                     WHERE S.CDEMPRESA  = P_CDEMPRESA
                       AND S.DTSALDEMPR = V_DATAFINAL
                       AND S.CDCONTCTBL = C_K155_AUX.CDCONTCTBL) SALDFIN
               WHERE SALDFIN.CDCONTCTBL = DEBITO.CDCONTCTBL(+)
                 AND SALDFIN.CDCONTCTBL = CREDITO.CDCONTCTBL(+)
                 AND SALDFIN.CDCONTCTBL = SALDINI.CDCONTCTBL(+)
                 AND (ABS(NVL(SALDINI.VRSALDINI,0)) + ABS(NVL(DEBITO.DEBITO,0)) + ABS(NVL(CREDITO.CREDITO,0))) <> 0
               ORDER BY SALDFIN.CDCONTCTBL) LOOP
                  /* VERIFICA SE O K030 JA FOI INSERIDO PARA O MES DO LOOP */
                  IF V_INSEREK030 = 'S' THEN
                     BEGIN
                        SELECT '|K030'                             ||'|'|| /* NOME DO REGISTRO */
                              TO_CHAR(V_DATAINICIAL, 'DDMMYYYY')   ||'|'|| /* DATA INICIAL DO PERIODO */
                              TO_CHAR(V_DATAFINAL, 'DDMMYYYY')     ||'|'|| /* DATA FINAL DO PERIODO */
                              'T'||V_MES                           ||'|'   /* PERIODO DE APURACAO */
                          INTO V_LINHA
                          FROM DUAL;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_LINHA := NULL;
                     END;
                     V_NRORDREGARQ := V_NRORDREGARQ + 1;
                     INSERT INTO ARQMAGNETICO
                        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                     VALUES
                        (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_LINHA, P_NRSEQARQMAG);
                     V_INSEREK030 := 'N';
                  END IF;
                  V_NRORDREGARQ := V_NRORDREGARQ + 1;

                  INSERT INTO ARQMAGNETICO
                    (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
                  VALUES
                    (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), C_K155.DSLINHA, P_NRSEQARQMAG);
                 END LOOP;
         END LOOP;
		 
         FOR K355 IN
            (SELECT '|K355|' || S.CDCONTCTBL || '|' || '' || '|' ||
                     REPLACE(LTRIM(TO_CHAR(ABS(NVL(NVL(ST.VRSALDOTRANSF, S.VRSALDEMPR), 0)),'9999999999990.00')), '.', ',')|| '|' ||
                     DECODE(NVL(NVL(ST.VRSALDOTRANSF, S.VRSALDEMPR), 0), ABS(NVL(NVL(ST.VRSALDOTRANSF, S.VRSALDEMPR), 0)), 'C', 'D') || '|' AS DSLINHA
               FROM SALDOTRANSF ST, SALDEMPR S, CONTCTBL C
              WHERE S.CDEMPRESA     = P_CDEMPRESA
                AND S.DTSALDEMPR = V_DATAFINAL
                AND S.CDCONTCTBL  = C.CDCONTCTBL
                AND C.IDTIPOCONT  = 'A'
                AND C.IDNATUCONT  = '04'
                AND C.IDCONTCCUS  <> 'R'
                AND S.DTSALDEMPR = ST.DTSALDOTRANSF(+)
                AND S.CDEMPRESA  = ST.CDEMPRESA(+)
                AND S.CDCONTCTBL = ST.CDCONTCTBL(+)
              ORDER BY S.CDCONTCTBL ASC, ST.DTSALDOTRANSF, S.DTSALDEMPR)LOOP
            V_NRORDREGARQ := V_NRORDREGARQ + 1;
            INSERT INTO ARQMAGNETICO
               (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
            VALUES
               (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), K355.DSLINHA, P_NRSEQARQMAG);
         END LOOP;
         V_DATAINICIAL := ADD_MONTHS(V_DATAINICIAL, 3);
         V_DATAFINAL := LAST_DAY(ADD_MONTHS(V_DATAFINAL, 3));
         V_INSEREK030 := 'S';
         V_COUNT := V_COUNT + 1;
      END LOOP;
   END IF;

   BEGIN
      SELECT '|K990'             ||'|'||  /* NOME DO REGISTRO */
             TO_CHAR(COUNT(*)+1) ||'|'    /* QUANTIDADE DE REGISTROS DO BLOCO K */
        INTO V_LINHA
        FROM ARQMAGNETICO
       WHERE NRSEQARQMAG = P_NRSEQARQMAG
         AND SUBSTR(DSREGARQMAG, 2, 1) = 'K';
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         V_LINHA := NULL;
   END;

   V_NRORDREGARQ := V_NRORDREGARQ + 1;
   INSERT INTO ARQMAGNETICO
     (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
   VALUES
     (LPAD(TO_CHAR(V_NRORDREGARQ),10,'0'), V_LINHA, P_NRSEQARQMAG);

   P_NRORDENACAO := V_NRORDREGARQ;
END;
/

